package com.ejie.ab79.dao.propuestaSancion;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.model.propuestaSancion.Calificaciones;
import com.ejie.ab79.model.propuestaSancion.Infracciones;

/**
 * 
 *  
 *
 */

@Repository
@Transactional
public class InfraccionesDaoImpl implements InfraccionesDao {

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */

	private RowMapper<Infracciones> rwMap = new RowMapper<Infracciones>() {
		public Infracciones mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Calificaciones calificaciones = new Calificaciones();
			calificaciones.setIdCalificacion(resultSet.getLong("IDCALIFICACION"));

			Infracciones infracciones = new Infracciones();
			infracciones.setIdInfraccion(resultSet.getInt("IDINFRACCION"));
			infracciones.setCalificaciones(calificaciones);
			infracciones.setArticulo(resultSet.getString("ARTICULO"));
			infracciones.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			infracciones.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));
			infracciones.setBaja(resultSet.getInt("BAJA"));
			infracciones.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			infracciones.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			infracciones.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			infracciones.setUsuarioRegistro(resultSet.getString("USUARIOULTMODIFICACION"));

			return infracciones;
		}
	};
	private RowMapper<Infracciones> comboMap = new RowMapper<Infracciones>() {
		public Infracciones mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			Infracciones infracciones = new Infracciones();
			infracciones.setIdInfraccion(resultSet.getInt("IDINFRACCION"));
			infracciones.setArticulo(resultSet.getString("ARTICULO"));
			infracciones.setDescripcionCastellano(resultSet.getString("DESCRIPCIONCASTELLANO"));
			infracciones.setDescripcionEuskera(resultSet.getString("DESCRIPCIONEUSKERA"));

			return infracciones;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/**
	 * Finds a list of rows in the Infracciones table.
	 *
	 * @param infracciones
	 *            Infracciones
	 * 
	 * @return List<Infracciones>
	 */

	@Transactional(readOnly = true)
	public List<Infracciones> cargarCombo(Infracciones infracciones) {
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_INFRACCION IDINFRACCION, t1.ARTICULO, t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO, t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA");
		query.append(" FROM INFRACCIONES t1 ");
		// where clause & params
		Map<String, ?> mapaWhere = this.getWhereMap(infracciones);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return (List<Infracciones>) this.jdbcTemplate.query(query.toString(), this.comboMap, params.toArray());
	}

	@Override
	public Infracciones find(Infracciones infraccion) {
		String query = "SELECT t1.ID_INFRACCION IDINFRACCION,t1.ID_CALIFICACION IDCALIFICACION,t1.ARTICULO,t1.DESCRIPCION_CASTELLANO DESCRIPCIONCASTELLANO,t1.DESCRIPCION_EUSKERA DESCRIPCIONEUSKERA,t1.BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO,t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION FROM INFRACCIONES t1 WHERE t1.ID_INFRACCION=?   ";
		List<Infracciones> infraccionesList = this.jdbcTemplate.query(query, this.rwMap, infraccion.getIdInfraccion());

		return (Infracciones) DataAccessUtils.uniqueResult(infraccionesList);

	}

	private Map<String, ?> getWhereMap(Infracciones infracciones) {

		StringBuilder where = new StringBuilder(InfraccionesDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (infracciones != null && infracciones.getProcedimiento() != null
				&& infracciones.getProcedimiento().getIdProcedimiento() != null) {
			where.append(" AND t1.ID_PROCEDIMIENTO = ?");
			params.add(infracciones.getProcedimiento().getIdProcedimiento());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
